#include <stdio.h>
#include <libakrypt.h>
#include "ak_bckey.h"
#include "ak_curves.h"
#include "ak_parameters.h"
#include <string.h>
#include <ak_hash.h>
/* ----------------------------------------------------------------------------------------------- */
bool_t test_vko(void)
{
    ak_uint8 k[64] = {
        0x64, 0x77, 0x0a, 0xf7, 0xf7, 0x48, 0xc3, 0xb1, 0xc9, 0xac, 0x83, 0x1d, 0xbc, 0xfd, 0x85, 0xc2,
        0x61, 0x11, 0xb3, 0x0a, 0x8a, 0x65, 0x7d, 0xdc, 0x30, 0x56, 0xb8, 0x0c, 0xa7, 0x3e, 0x04, 0x0d,
        0x28, 0x54, 0xfd, 0x36, 0x81, 0x1f, 0x6d, 0x82, 0x5c, 0xc4, 0xab, 0x66, 0xec, 0x0a, 0x68, 0xa4,
        0x90, 0xa9, 0xe5, 0xcf, 0x51, 0x56, 0xb3, 0xa2, 0xb7, 0xee, 0xcd, 0xdb, 0xf9, 0xa1, 0x6b, 0x47
    };
    int reason = ak_error_ok;
    char *str = NULL;
    if(( reason = ak_wcurve_is_ok( &id_tc26_gost_3410_2012_256_paramSetA )) != ak_error_ok )
        return reason;


    struct wpoint wr;
    ak_wcurve wc = &wr;//( ak_wcurve ) id_tc26_gost_3410_2012_256_paramSetA. key.data;
//    ak_uint64 *r = (ak_uint64 *)out, *s = ( ak_uint64 *)out + wc->size;

    /* поскольку функция не экспортируется, мы оставляем все проверки функциям верхнего уровня */
    /* вычисляем r */
    ak_wpoint_pow( &wr, &wc->point, k, wc->size,  &id_tc26_gost_3410_2012_256_paramSetA  );

    ak_log_set_message(str = ak_ptr_to_hexstr(&id_tc26_gost_3410_2012_256_paramSetA, 64, ak_false)); free(str);
    bool_t ak_wpoint_check_order( ak_wpoint wp, ak_wcurve ec );

    return ak_error_ok;

}

/* ----------------------------------------------------------------------------------------------- */
bool_t hmac_test_pbkdf2(void)
{
	ak_uint8 R1[64] = {
		0x64, 0x77, 0x0a, 0xf7, 0xf7, 0x48, 0xc3, 0xb1, 0xc9, 0xac, 0x83, 0x1d, 0xbc, 0xfd, 0x85, 0xc2,
		0x61, 0x11, 0xb3, 0x0a, 0x8a, 0x65, 0x7d, 0xdc, 0x30, 0x56, 0xb8, 0x0c, 0xa7, 0x3e, 0x04, 0x0d,
		0x28, 0x54, 0xfd, 0x36, 0x81, 0x1f, 0x6d, 0x82, 0x5c, 0xc4, 0xab, 0x66, 0xec, 0x0a, 0x68, 0xa4,
		0x90, 0xa9, 0xe5, 0xcf, 0x51, 0x56, 0xb3, 0xa2, 0xb7, 0xee, 0xcd, 0xdb, 0xf9, 0xa1, 0x6b, 0x47
	};

	ak_uint8 R2[64] = {
		0x5a, 0x58, 0x5b, 0xaf, 0xdf, 0xbb, 0x6e, 0x88, 0x30, 0xd6, 0xd6, 0x8a, 0xa3, 0xb4, 0x3a, 0xc0,
		0x0d, 0x2e, 0x4a, 0xeb, 0xce, 0x01, 0xc9, 0xb3, 0x1c, 0x2c, 0xae, 0xd5, 0x6f, 0x02, 0x36, 0xd4,
		0xd3, 0x4b, 0x2b, 0x8f, 0xbd, 0x2c, 0x4e, 0x89, 0xd5, 0x4d, 0x46, 0xf5, 0x0e, 0x47, 0xd4, 0x5b,
		0xba, 0xc3, 0x01, 0x57, 0x17, 0x43, 0x11, 0x9e, 0x8d, 0x3c, 0x42, 0xba, 0x66, 0xd3, 0x48, 0xde
	};

	ak_uint8 R3[64] = {
		0xe5, 0x2d, 0xeb, 0x9a, 0x2d, 0x2a, 0xaf, 0xf4, 0xe2, 0xac, 0x9d, 0x47, 0xa4, 0x1f, 0x34, 0xc2,
		0x03, 0x76, 0x59, 0x1c, 0x67, 0x80, 0x7f, 0x04, 0x77, 0xe3, 0x25, 0x49, 0xdc, 0x34, 0x1b, 0xc7,
		0x86, 0x7c, 0x09, 0x84, 0x1b, 0x6d, 0x58, 0xe2, 0x9d, 0x03, 0x47, 0xc9, 0x96, 0x30, 0x1d, 0x55,
		0xdf, 0x0d, 0x34, 0xe4, 0x7c, 0xf6, 0x8f, 0x4e, 0x3c, 0x2c, 0xda, 0xf1, 0xd9, 0xab, 0x86, 0xc3
	};

	ak_uint8 R4[64] = {
		0x50, 0xdf, 0x06, 0x28, 0x85, 0xb6, 0x98, 0x01, 0xa3, 0xc1, 0x02, 0x48, 0xeb, 0x0a, 0x27, 0xab,
		0x6e, 0x52, 0x2f, 0xfe, 0xb2, 0x0c, 0x99, 0x1c, 0x66, 0x0f, 0x00, 0x14, 0x75, 0xd7, 0x3a, 0x4e,
		0x16, 0x7f, 0x78, 0x2c, 0x18, 0xe9, 0x7e, 0x92, 0x97, 0x6d, 0x9c, 0x1d, 0x97, 0x08, 0x31, 0xea,
		0x78, 0xcc, 0xb8, 0x79, 0xf6, 0x70, 0x68, 0xcd, 0xac, 0x19, 0x10, 0x74, 0x08, 0x44, 0xe8, 0x30
	};

	ak_uint8 password_one[8] = "password",
		password_two[9] = { 'p', 'a', 's', 's', 0, 'w', 'o', 'r', 'd' },
		salt_one[4] = "salt",
		salt_two[5] = { 's', 'a', 0, 'l', 't' };

	ak_uint8 passwordMicron[16] = { 0xAF ,0x2A ,0x91 ,0x87 ,0xFF ,0xF0 ,0x70 ,0xD2 ,0x24 ,0xD3 ,0x6F ,0x58 ,0x0A ,0x9E ,0x8A ,0x8D };
	ak_uint8 saltMicron[16] = { 0x3A ,0x9C ,0x19 ,0x7B ,0x86 ,0x9D ,0x30 ,0x27 ,0xCB ,0x11 ,0xB2 ,0xA5 ,0x19 ,0xA9 ,0x09 ,0x38 };

	ak_uint8 passwordMicron_[16] = { 0x8D,0x8A,0x9E,0x0A,0x58,0x6F,0xD3,0x24,0xD2,0x70,0xF0,0xFF,0x87,0x91,0x2A,0xAF };
	ak_uint8 saltMicron_[16] = { 0x38,0x09,0xA9,0x19,0xA5,0xB2,0x11,0xCB,0x27,0x30,0x9D,0x86,0x7B,0x19,0x9C,0x3A };
	
	ak_uint8 out[64];
	char *str = NULL;
	int error = ak_error_ok;
	int audit = ak_log_get_level();

	ak_log_set_message(str = ak_ptr_to_hexstr(passwordMicron, 16, ak_true)); free(str);
	ak_log_set_message(str = ak_ptr_to_hexstr(saltMicron, 16, ak_true)); free(str);

	/* первый тест из Р 50.1.111-2016 */
	if ((error = ak_hmac_context_pbkdf2_streebog512(passwordMicron, 16,
		saltMicron, 16, 2000, 64, out)) != ak_error_ok) {
		ak_error_message(error, __func__, "incorrect transformation password to key");
		return ak_false;
	}
	if (!ak_ptr_is_equal(out, R1, 64)) {
		ak_error_message(ak_error_not_equal_data, __func__,
			"wrong 1st test for pbkdf2 from R 50.1.111-2016");
		ak_log_set_message(str = ak_ptr_to_hexstr(out, 64, ak_false)); free(str);
		ak_log_set_message(str = ak_ptr_to_hexstr(R1, 64, ak_false)); free(str);
		return ak_false;
	}
	if (audit >= ak_log_maximum) ak_error_message(ak_error_ok, __func__,
		"the 1st test for pbkdf2 from R 50.1.111-2016 is Ok");

	/* второй тест из Р 50.1.111-2016 */
	if ((error = ak_hmac_context_pbkdf2_streebog512(password_one, 8,
		salt_one, 4, 2, 64, out)) != ak_error_ok) {
		ak_error_message(error, __func__, "incorrect transformation password to key");
		return ak_false;
	}
	if (!ak_ptr_is_equal(out, R2, 64)) {
		ak_error_message(ak_error_not_equal_data, __func__,
			"wrong 2nd test for pbkdf2 from R 50.1.111-2016");
		ak_log_set_message(str = ak_ptr_to_hexstr(out, 64, ak_false)); free(str);
		ak_log_set_message(str = ak_ptr_to_hexstr(R2, 64, ak_false)); free(str);
		return ak_false;
	}
	if (audit >= ak_log_maximum) ak_error_message(ak_error_ok, __func__,
		"the 2nd test for pbkdf2 from R 50.1.111-2016 is Ok");

	/* третий тест из Р 50.1.111-2016 */
	if ((error = ak_hmac_context_pbkdf2_streebog512(password_one, 8,
		salt_one, 4, 4096, 64, out)) != ak_error_ok) {
		ak_error_message(error, __func__, "incorrect transformation password to key");
		return ak_false;
	}
	if (!ak_ptr_is_equal(out, R3, 64)) {
		ak_error_message(ak_error_not_equal_data, __func__,
			"wrong 3rd test for pbkdf2 from R 50.1.111-2016");
		ak_log_set_message(str = ak_ptr_to_hexstr(out, 64, ak_false)); free(str);
		ak_log_set_message(str = ak_ptr_to_hexstr(R3, 64, ak_false)); free(str);
		return ak_false;
	}
	if (audit >= ak_log_maximum) ak_error_message(ak_error_ok, __func__,
		"the 3rd test for pbkdf2 from R 50.1.111-2016 is Ok");

	/* четвертый тест из Р 50.1.111-2016 */
	if ((error = ak_hmac_context_pbkdf2_streebog512(password_two, 9,
		salt_two, 5, 4096, 64, out)) != ak_error_ok) {
		ak_error_message(error, __func__, "incorrect transformation password to key");
		return ak_false;
	}
	if (!ak_ptr_is_equal(out, R4, 64)) {
		ak_error_message(ak_error_not_equal_data, __func__,
			"wrong 4th test for pbkdf2 from R 50.1.111-2016");
		ak_log_set_message(str = ak_ptr_to_hexstr(out, 64, ak_false)); free(str);
		ak_log_set_message(str = ak_ptr_to_hexstr(R4, 64, ak_false)); free(str);
		return ak_false;
	}
	if (audit >= ak_log_maximum) ak_error_message(ak_error_ok, __func__,
		"the 4th test for pbkdf2 from R 50.1.111-2016 is Ok");

	return ak_true;
}

/*
ak_uint8 keyMicron[32] = {
	0x48 , 0x1D , 0x4F , 0x25 , 0x30 , 0x78 , 0x70 , 0x3E , 0x23 , 0xC6 , 0x71 , 0x0B , 0xA6 , 0x77 , 0x64 , 0x46,
	0xA4 , 0xE5 , 0x54 , 0x4C , 0x9B , 0xCC , 0x0F , 0x67 , 0x2A , 0x22 , 0x4C , 0xAF , 0x0E , 0xCD , 0xB3 , 0x5A };

ak_uint8 dataMicron[64] = {
	0x8C ,0x90 ,0xF7 ,0x17 ,0x9B ,0x72 ,0x62 ,0xB4 ,0x5D ,0x9C ,0xA3 ,0x8C ,0x4E ,0xDB ,0xB6 ,0x59,
	0x26 ,0x50 ,0x08 ,0x4C ,0xC5 ,0xC6 ,0xF2 ,0xB4 ,0xB9 ,0x91 ,0x5F ,0x63 ,0xCD ,0xF6 ,0x88 ,0x16,
	0x5C ,0x2B ,0x3A ,0xBD ,0xF6 ,0x7E ,0xC5 ,0x70 ,0x9F ,0x87 ,0x4F ,0xFA ,0x2A ,0xF7 ,0x85 ,0x2B,
	0x55 ,0x7A ,0x73 ,0x60 ,0xFA ,0x99 ,0x08 ,0x8B ,0x6C ,0xDF ,0x75 ,0x50 ,0x23 ,0xC0 ,0x2F ,0x8E };
	*/
	/* ----------------------------------------------------------------------------------------------- */
	/*                            функции для тестирования алгоритма hmac                              */
	/* ----------------------------------------------------------------------------------------------- */
bool_t hmac_test_streebog(void)
{
	ak_uint8 key[32] = {
		0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f,
		0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19, 0x1a, 0x1b, 0x1c, 0x1d, 0x1e, 0x1f
	};

	ak_uint8 keyMicron[32] = {
		0x48 , 0x1D , 0x4F , 0x25 , 0x30 , 0x78 , 0x70 , 0x3E , 0x23 , 0xC6 , 0x71 , 0x0B , 0xA6 , 0x77 , 0x64 , 0x46,
		0xA4 , 0xE5 , 0x54 , 0x4C , 0x9B , 0xCC , 0x0F , 0x67 , 0x2A , 0x22 , 0x4C , 0xAF , 0x0E , 0xCD , 0xB3 , 0x5A };

	ak_uint8 dataMicron[64] = {
		0x8C ,0x90 ,0xF7 ,0x17 ,0x9B ,0x72 ,0x62 ,0xB4 ,0x5D ,0x9C ,0xA3 ,0x8C ,0x4E ,0xDB ,0xB6 ,0x59,
		0x26 ,0x50 ,0x08 ,0x4C ,0xC5 ,0xC6 ,0xF2 ,0xB4 ,0xB9 ,0x91 ,0x5F ,0x63 ,0xCD ,0xF6 ,0x88 ,0x16,
		0x5C ,0x2B ,0x3A ,0xBD ,0xF6 ,0x7E ,0xC5 ,0x70 ,0x9F ,0x87 ,0x4F ,0xFA ,0x2A ,0xF7 ,0x85 ,0x2B,
		0x55 ,0x7A ,0x73 ,0x60 ,0xFA ,0x99 ,0x08 ,0x8B ,0x6C ,0xDF ,0x75 ,0x50 ,0x23 ,0xC0 ,0x2F ,0x8E };


	ak_uint8 data[16] = {
		0x01, 0x26, 0xbd, 0xb8, 0x78, 0x00, 0xaf, 0x21, 0x43, 0x41, 0x45, 0x65, 0x63, 0x78, 0x01, 0x00
	};

	ak_uint8 R256[32] = {
		0xa1, 0xaa, 0x5f, 0x7d, 0xe4, 0x02, 0xd7, 0xb3, 0xd3, 0x23, 0xf2, 0x99, 0x1c, 0x8d, 0x45, 0x34,
		0x01, 0x31, 0x37, 0x01, 0x0a, 0x83, 0x75, 0x4f, 0xd0, 0xaf, 0x6d, 0x7c, 0xd4, 0x92, 0x2e, 0xd9
	};

	ak_uint8 R512[64] = {
		0xa5, 0x9b, 0xab, 0x22, 0xec, 0xae, 0x19, 0xc6, 0x5f, 0xbd, 0xe6, 0xe5, 0xf4, 0xe9, 0xf5, 0xd8,
		0x54, 0x9d, 0x31, 0xf0, 0x37, 0xf9, 0xdf, 0x9b, 0x90, 0x55, 0x00, 0xe1, 0x71, 0x92, 0x3a, 0x77,
		0x3d, 0x5f, 0x15, 0x30, 0xf2, 0xed, 0x7e, 0x96, 0x4c, 0xb2, 0xee, 0xdc, 0x29, 0xe9, 0xad, 0x2f,
		0x3a, 0xfe, 0x93, 0xb2, 0x81, 0x4f, 0x79, 0xf5, 0x00, 0x0f, 0xfc, 0x03, 0x66, 0xc2, 0x51, 0xe6
	};

	struct hmac hkey;
	char *str = NULL;
	ak_uint8 out[64];
	int error = ak_error_ok;
	bool_t result = ak_true;
	int audit = ak_log_get_level();

	/* 1. тестируем HMAC на основе Стрибог 256 */
	if ((error = ak_hmac_context_create_streebog256(&hkey)) != ak_error_ok) {
		ak_error_message(error, __func__, "wrong creation of hmac-streebog256 key context");
		return ak_false;
	}
	if ((error = ak_hmac_context_set_key(&hkey, keyMicron, 32, ak_true)) != ak_error_ok) {
		ak_error_message(error, __func__, "wrong assigning a constant hmac key value");
		result = ak_false;
		goto lab_exit;
	}
	memset(out, 0, 64);
	ak_hmac_context_ptr(&hkey, dataMicron, 64, out);
	if (ak_error_get_value() != ak_error_ok) {
		ak_error_message(error, __func__, "incorrect calculation of hmac code");
		result = ak_false;
		goto lab_exit;
	}
	if (!ak_ptr_is_equal(out, R256, 32)) {
		ak_error_message(ak_error_not_equal_data, __func__,
			"wrong test for hmac-streebog256 from R 50.1.113-2016");
		ak_log_set_message(str = ak_ptr_to_hexstr(out, 32, ak_false)); free(str);
		ak_log_set_message(str = ak_ptr_to_hexstr(R256, 32, ak_false)); free(str);
		result = ak_false;
		goto lab_exit;
	}

	if (audit >= ak_log_maximum) ak_error_message(ak_error_ok, __func__,
		"test for hmac-streebog256 from R 50.1.113-2016 is Ok");
	ak_hmac_context_destroy(&hkey);

	/* 2. тестируем HMAC на основе Стрибог 512 */
	if ((error = ak_hmac_context_create_streebog512(&hkey)) != ak_error_ok) {
		ak_error_message(error, __func__, "wrong creation of hmac-streebog512 key context");
		return ak_false;
	}
	if ((error = ak_hmac_context_set_key(&hkey, key, 32, ak_true)) != ak_error_ok) {
		ak_error_message(error, __func__, "wrong assigning a constant hmac key value");
		result = ak_false;
		goto lab_exit;
	}
	memset(out, 0, 64);
	ak_hmac_context_ptr(&hkey, data, 16, out);
	if (ak_error_get_value() != ak_error_ok) {
		ak_error_message(error, __func__, "incorrect calculation of hmac code");
		result = ak_false;
		goto lab_exit;
	}
	if (!ak_ptr_is_equal(out, R512, 64)) {
		ak_error_message(ak_error_not_equal_data, __func__,
			"wrong test for hmac-streebog512 from R 50.1.113-2016");
		ak_log_set_message(str = ak_ptr_to_hexstr(out, 64, ak_false)); free(str);
		ak_log_set_message(str = ak_ptr_to_hexstr(R512, 64, ak_false)); free(str);
		result = ak_false;
		goto lab_exit;
	}

	if (audit >= ak_log_maximum) ak_error_message(ak_error_ok, __func__,
		"test for hmac-streebog512 from R 50.1.113-2016 is Ok");
lab_exit:
	ak_hmac_context_destroy(&hkey);
	return result;
}
/* ----------------------------------------------------------------------------------------------- */
/* ----------------------------------------------------------------------------------------------- */
/*! первое тестовое сообщение (см. текст стандарта ГОСТ Р 34.11-2012, прил. А, пример 1) */
static ak_uint8 streebog_M1_message[63] = {
	0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39,
	0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39,
	0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39,
	0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39,
	0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39,
	0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39,
	0x30, 0x31, 0x32 };

/*! второе тестовое сообщение (см. текст стандарта ГОСТ Р 34.11-2012, прил. А, пример 2) */
static ak_uint8 streebog_M2_message[72] = {
	0xd1, 0xe5, 0x20, 0xe2, 0xe5, 0xf2, 0xf0, 0xe8, 0x2c, 0x20, 0xd1, 0xf2, 0xf0, 0xe8,
	0xe1, 0xee, 0xe6, 0xe8, 0x20, 0xe2, 0xed, 0xf3, 0xf6, 0xe8, 0x2c, 0x20, 0xe2, 0xe5,
	0xfe, 0xf2, 0xfa, 0x20, 0xf1, 0x20, 0xec, 0xee, 0xf0, 0xff, 0x20, 0xf1, 0xf2, 0xf0,
	0xe5, 0xeb, 0xe0, 0xec, 0xe8, 0x20, 0xed, 0xe0, 0x20, 0xf5, 0xf0, 0xe0, 0xe1, 0xf0,
	0xfb, 0xff, 0x20, 0xef, 0xeb, 0xfa, 0xea, 0xfb, 0x20, 0xc8, 0xe3, 0xee, 0xf0, 0xe5,
	0xe2, 0xfb };
static ak_uint8 streebog256_Micron[64] = {
   0x7F ,0x74 ,0x3A ,0x94 ,0xA4 ,0x46 ,0xBC ,0xE6 ,0x82 ,0x58 ,0xF2 ,0x43 ,0x8C ,0xCF ,0x23 ,0x5C,
   0x92 ,0x6D ,0xA6 ,0x64 ,0x59 ,0x5A ,0x2F ,0x45 ,0xD2 ,0xC3 ,0x33 ,0x90 ,0x36 ,0x3A ,0x4F ,0xEE,
   0x58 ,0x9F ,0xCF ,0xE8 ,0x4C ,0xA6 ,0x42 ,0x47 ,0xFD ,0x8B ,0x0B ,0x02 ,0x7C ,0x8A ,0x89 ,0xA0,
   0xB0 ,0x3E ,0xA3 ,0x68 ,0xA5 ,0x7F ,0x4B ,0xD4 ,0x0F ,0x0F ,0x1D ,0x50 ,0x5F ,0x91 ,0x29 ,0x35 };




static ak_uint8 streebog256_testM1[32] = {
	0x9D, 0x15, 0x1E, 0xEF, 0xD8, 0x59, 0x0B, 0x89, 0xDA, 0xA6, 0xBA, 0x6C, 0xB7, 0x4A, 0xF9, 0x27,
	0x5D, 0xD0, 0x51, 0x02, 0x6B, 0xB1, 0x49, 0xA4, 0x52, 0xFD, 0x84, 0xE5, 0xE5, 0x7B, 0x55, 0x00
};

static ak_uint8 streebog256_testM2[32] = {
	0x9D, 0xD2, 0xFE, 0x4E, 0x90, 0x40, 0x9E, 0x5D, 0xA8, 0x7F, 0x53, 0x97, 0x6D, 0x74, 0x05, 0xB0,
	0xC0, 0xCA, 0xC6, 0x28, 0xFC, 0x66, 0x9A, 0x74, 0x1D, 0x50, 0x06, 0x3C, 0x55, 0x7E, 0x8F, 0x50
};

static ak_uint8 streebog256_testM3[32] = {
	0x3E, 0x7D, 0xEA, 0x7F, 0x23, 0x84, 0xB6, 0xC5, 0xA3, 0xD0, 0xE2, 0x4A, 0xAA, 0x29, 0xC0, 0x5E,
	0x89, 0xDD, 0xD7, 0x62, 0x14, 0x50, 0x30, 0xEC, 0x22, 0xC7, 0x1A, 0x6D, 0xB8, 0xB2, 0xC1, 0xF4
};

static ak_uint8 streebog256_testM4[32] = {
	0x36, 0x81, 0x6A, 0x82, 0x4D, 0xCB, 0xE7, 0xD6, 0x17, 0x1A, 0xA5, 0x85, 0x00, 0x74, 0x1F, 0x2E,
	0xA2, 0x75, 0x7A, 0xE2, 0xE1, 0x78, 0x4A, 0xB7, 0x2C, 0x5C, 0x3C, 0x6C, 0x19, 0x8D, 0x71, 0xDA
};

static ak_uint8 streebog256_testM5[32] = {
	0x3F, 0x53, 0x9A, 0x21, 0x3E, 0x97, 0xC8, 0x02, 0xCC, 0x22, 0x9D, 0x47, 0x4C, 0x6A, 0xA3, 0x2A,
	0x82, 0x5A, 0x36, 0x0B, 0x2A, 0x93, 0x3A, 0x94, 0x9F, 0xD9, 0x25, 0x20, 0x8D, 0x9C, 0xE1, 0xBB
};

static ak_uint8 streebog512_testM1[64] = {
	0x1B, 0x54, 0xD0, 0x1A, 0x4A, 0xF5, 0xB9, 0xD5, 0xCC, 0x3D, 0x86, 0xD6, 0x8D, 0x28, 0x54, 0x62,
	0xB1, 0x9A, 0xBC, 0x24, 0x75, 0x22, 0x2F, 0x35, 0xC0, 0x85, 0x12, 0x2B, 0xE4, 0xBA, 0x1F, 0xFA,
	0x00, 0xAD, 0x30, 0xF8, 0x76, 0x7B, 0x3A, 0x82, 0x38, 0x4C, 0x65, 0x74, 0xF0, 0x24, 0xC3, 0x11,
	0xE2, 0xA4, 0x81, 0x33, 0x2B, 0x08, 0xEF, 0x7F, 0x41, 0x79, 0x78, 0x91, 0xC1, 0x64, 0x6F, 0x48
};

static ak_uint8 streebog512_testM2[64] = {
	0x1E, 0x88, 0xE6, 0x22, 0x26, 0xBF, 0xCA, 0x6F, 0x99, 0x94, 0xF1, 0xF2, 0xD5, 0x15, 0x69, 0xE0,
	0xDA, 0xF8, 0x47, 0x5A, 0x3B, 0x0F, 0xE6, 0x1A, 0x53, 0x00, 0xEE, 0xE4, 0x6D, 0x96, 0x13, 0x76,
	0x03, 0x5F, 0xE8, 0x35, 0x49, 0xAD, 0xA2, 0xB8, 0x62, 0x0F, 0xCD, 0x7C, 0x49, 0x6C, 0xE5, 0xB3,
	0x3F, 0x0C, 0xB9, 0xDD, 0xDC, 0x2B, 0x64, 0x60, 0x14, 0x3B, 0x03, 0xDA, 0xBA, 0xC9, 0xFB, 0x28
};

static ak_uint8 streebog512_testM3[64] = {
	0x8E, 0x94, 0x5D, 0xA2, 0x09, 0xAA, 0x86, 0x9F, 0x04, 0x55, 0x92, 0x85, 0x29, 0xBC, 0xAE, 0x46,
	0x79, 0xE9, 0x87, 0x3A, 0xB7, 0x07, 0xB5, 0x53, 0x15, 0xF5, 0x6C, 0xEB, 0x98, 0xBE, 0xF0, 0xA7,
	0x36, 0x2F, 0x71, 0x55, 0x28, 0x35, 0x6E, 0xE8, 0x3C, 0xDA, 0x5F, 0x2A, 0xAC, 0x4C, 0x6A, 0xD2,
	0xBA, 0x3A, 0x71, 0x5C, 0x1B, 0xCD, 0x81, 0xCB, 0x8E, 0x9F, 0x90, 0xBF, 0x4C, 0x1C, 0x1A, 0x8A
};

bool_t test_streebog256(void)
{
	struct hash ctx; /* контекст функции хеширования */
	ak_uint8 out[32]; /* буффер длиной 32 байта (256 бит) для получения результата */
	char *str = NULL;
	int error = ak_error_ok;
	bool_t result = ak_true;
	int audit = ak_log_get_level();

	/* инициализируем контекст функции хешиирования */
	if ((error = ak_hash_context_create_streebog256(&ctx)) != ak_error_ok) {
		ak_error_message(error, __func__, "wrong initialization of streenbog256 context");
		return ak_false;
	}

	/* первый пример из приложения А (ГОСТ Р 34.11-2012) */
	ak_hash_context_ptr(&ctx, streebog_M1_message, 63, out);
	if ((error = ak_error_get_value()) != ak_error_ok) {
		ak_error_message(error, __func__, "invalid calculation of streebog256 code");
		result = ak_false;
		goto lab_exit;
	}

	if (ak_ptr_is_equal(streebog256_testM1, out, 32)) {
		if (audit >= ak_log_maximum)
			ak_error_message(ak_error_ok, __func__, "the 1st test from GOST R 34.11-2012 is Ok");
	}
	else {
		ak_error_message(ak_error_not_equal_data, __func__,
			"the 1st test from GOST R 34.11-2012 is wrong");
		ak_log_set_message((str = ak_ptr_to_hexstr(out, 32, ak_false))); free(str);
		ak_log_set_message((str = ak_ptr_to_hexstr(streebog256_testM1, 32, ak_false))); free(str);
		result = ak_false;
		goto lab_exit;
	}

	/* второй пример из приложения А (ГОСТ Р 34.11-2012) */
	ak_hash_context_ptr(&ctx, streebog256_Micron, 64, out);
	if ((error = ak_error_get_value()) != ak_error_ok) {
		ak_error_message(error, __func__, "invalid calculation of streebog256 code");
		result = ak_false;
		goto lab_exit;
	}

	if (ak_ptr_is_equal(streebog256_testM2, out, 32)) {
		if (audit >= ak_log_maximum)
			ak_error_message(ak_error_ok, __func__, "the 2nd test from GOST R 34.11-2012 is Ok");
	}
	else {
		ak_error_message(ak_error_not_equal_data, __func__,
			"the 2nd test from GOST R 34.11-2012 is wrong");
		ak_log_set_message((str = ak_ptr_to_hexstr(out, 32, ak_false))); free(str);
		ak_log_set_message((str = ak_ptr_to_hexstr(streebog256_testM2, 32, ak_false))); free(str);
		result = ak_false;
		goto lab_exit;
	}

	/* первый пример из Википедии */
	ak_hash_context_ptr(&ctx, "The quick brown fox jumps over the lazy dog", 43, out);
	if ((error = ak_error_get_value()) != ak_error_ok) {
		ak_error_message(error, __func__, "invalid calculation of streebog256 code");
		result = ak_false;
		goto lab_exit;
	}

	if (ak_ptr_is_equal(streebog256_testM3, out, 32)) {
		if (audit >= ak_log_maximum)
			ak_error_message(ak_error_ok, __func__, "the \"lazy dog\" test from Wikipedia is Ok");
	}
	else {
		ak_error_message(ak_error_not_equal_data, __func__,
			"the \"lazy dog\" test from Wikipedia is wrong");
		ak_log_set_message((str = ak_ptr_to_hexstr(out, 32, ak_false))); free(str);
		ak_log_set_message((str = ak_ptr_to_hexstr(streebog256_testM3, 32, ak_false))); free(str);
		result = ak_false;
		goto lab_exit;
	}

	/* второй пример из Википедии */
	ak_hash_context_ptr(&ctx, "The quick brown fox jumps over the lazy dog.", 44, out);
	if ((error = ak_error_get_value()) != ak_error_ok) {
		ak_error_message(error, __func__, "invalid calculation of streebog256 code");
		result = ak_false;
		goto lab_exit;
	}

	if (ak_ptr_is_equal(streebog256_testM4, out, 32)) {
		if (audit >= ak_log_maximum)
			ak_error_message(ak_error_ok, __func__,
				"the \"lazy dog with point\" test from Wikipedia is Ok");
	}
	else {
		ak_error_message(ak_error_not_equal_data, __func__,
			"the \"lazy dog with point\" test from Wikipedia is wrong");
		ak_log_set_message((str = ak_ptr_to_hexstr(out, 32, ak_false))); free(str);
		ak_log_set_message((str = ak_ptr_to_hexstr(streebog256_testM4, 32, ak_false))); free(str);
		result = ak_false;
		goto lab_exit;
	}

	/* хеширование пустого вектора */
	ak_hash_context_ptr(&ctx, "", 0, out);
	if ((error = ak_error_get_value()) != ak_error_ok) {
		ak_error_message(error, __func__, "invalid calculation of streebog256 code");
		result = ak_false;
		goto lab_exit;
	}

	if (ak_ptr_is_equal(streebog256_testM5, out, 32)) {
		if (audit >= ak_log_maximum)
			ak_error_message(ak_error_ok, __func__, "the zero length vector test is Ok");
	}
	else {
		ak_error_message(ak_error_not_equal_data, __func__, "the zero length vector test is wrong");
		ak_log_set_message((str = ak_ptr_to_hexstr(out, 32, ak_false))); free(str);
		ak_log_set_message((str = ak_ptr_to_hexstr(streebog256_testM5, 32, ak_false))); free(str);
		result = ak_false;
		goto lab_exit;
	}

	/* уничтожаем контекст */
lab_exit: ak_hash_context_destroy(&ctx);
	return result;
}
/* ----------------------------------------------------------------------------------------------- */
bool_t signkey_test(void)
{
	/* секретные ключи определяются последовательностями байт */
	/* d = "7A929ADE789BB9BE10ED359DD39A72C11B60961F49397EEE1D19CE9891EC3B28"; */
	ak_uint8 key256[32] = {
		0x28, 0x3B, 0xEC, 0x91, 0x98, 0xCE, 0x19, 0x1D, 0xEE, 0x7E, 0x39, 0x49, 0x1F, 0x96, 0x60, 0x1B,
		0xC1, 0x72, 0x9A, 0xD3, 0x9D, 0x35, 0xED, 0x10, 0xBE, 0xB9, 0x9B, 0x78, 0xDE, 0x9A, 0x92, 0x7A };

	/* секретные ключи определяются последовательностями байт */
	/* d = "D0 B4 8F 74 42 59 67 44 F4 3F 89 C2 B6 EA CE 4C 0D 68 54 63 B1 07 BC 07 83 EA E6 1D B3 06 75 26"; */
	/* d = "267506B31DE6EA8307BC07B16354680D4CCEEAB6C2893FF444675942748FB4D0"; */
	ak_uint8 keyMicron256[32] = {
		0x26, 0x75, 0x06, 0xB3, 0x1D, 0xE6, 0xEA, 0x83, 0x07, 0xBC, 0x07, 0xB1, 0x63, 0x54, 0x68, 0x0D,
		0x4C, 0xCE, 0xEA, 0xB6, 0xC2, 0x89, 0x3F, 0xF4, 0x44, 0x67, 0x59, 0x42, 0x74, 0x8F, 0xB4, 0xD0};
	ak_uint8 keyMicron256_[32] = {
		0xD0 , 0xB4 , 0x8F , 0x74 , 0x42 , 0x59 , 0x67 , 0x44 , 0xF4 , 0x3F , 0x89 , 0xC2 , 0xB6 , 0xEA , 0xCE , 0x4C,
		0x0D ,0x68 ,0x54 ,0x63 ,0xB1 ,0x07 ,0xBC ,0x07 ,0x83 ,0xEA ,0xE6 ,0x1D ,0xB3 ,0x06 ,0x75 ,0x26 };

	/* d = BA6048AADAE241BA40936D47756D7C93091A0E8514669700EE7508E508B102072E8123B2200A0563322DAD2827E2714A2636B7BFD18AADFC62967821FA18DD4 */
	ak_uint8 key512[64] = {
		0xd4, 0x8d, 0xa1, 0x1f, 0x82, 0x67, 0x29, 0xc6, 0xdf, 0xaa, 0x18, 0xfd, 0x7b, 0x6b, 0x63, 0xa2,
		0x14, 0x27, 0x7e, 0x82, 0xd2, 0xda, 0x22, 0x33, 0x56, 0xa0, 0x00, 0x22, 0x3b, 0x12, 0xe8, 0x72,
		0x20, 0x10, 0x8b, 0x50, 0x8e, 0x50, 0xe7, 0x0e, 0x70, 0x69, 0x46, 0x51, 0xe8, 0xa0, 0x91, 0x30,
		0xc9, 0xd7, 0x56, 0x77, 0xd4, 0x36, 0x09, 0xa4, 0x1b, 0x24, 0xae, 0xad, 0x8a, 0x04, 0xa6, 0x0b };


	/* промежуточные значения являются большими целыми числами и, следовательно,
	представляются в виде последовательности коэффициентов в системе счисления по основанию 2^64  */
	/* е = 2DFBC1B372D89A11 88C09C52E0EEC61F CE52032AB1022E8E 67ECE6672B043EE5 */
	ak_uint64 e256[ak_mpzn256_size] =
	{ 0x67ECE6672B043EE5LL, 0xCE52032AB1022E8ELL, 0x88C09C52E0EEC61FLL, 0x2DFBC1B372D89A11LL };

	/* е = 1D95EDBABC94B743 08E851998F3E5395 A5B68EBD53F86A4D EB6F3E880A60D122 */
	ak_uint64 eMicron256[ak_mpzn256_size] =
	{ 0xEB6F3E880A60D122LL, 0xA5B68EBD53F86A4DLL, 0x08E851998F3E5395LL, 0x1D95EDBABC94B743LL };

	/* е = 22D1600A883E6FEB 4D6AF853BD8EB6A5 95533E8F9951E808 43B794BCBAED951D  */
	ak_uint64 eMicron256_[ak_mpzn256_size] =
	{ 0x43B794BCBAED951DLL, 0x95533E8F9951E808LL, 0x4D6AF853BD8EB6A5LL, 0x22D1600A883E6FEBLL };

	/* е = 3754F3CFACC9E0615C4F4A7C4D8DAB531B09B6F9C170C533A71D147035B0C5917184EE536593F4414339976C647C5D5A407ADEDB1D560C4FC6777D2972075B8C */
	ak_uint64 e512[ak_mpzn512_size] =
	{ 0xC6777D2972075B8CLL, 0x407ADEDB1D560C4FLL, 0x4339976C647C5D5ALL, 0x7184EE536593F441,
		0xA71D147035B0C591LL, 0x1B09B6F9C170C533LL, 0x5C4F4A7C4D8DAB53LL, 0x3754F3CFACC9E061 };

	/* k = 77105C9B20BCD3122823C8CF6FCC7B956DE33814E95B7FE64FED924594DCEAB3 */
	ak_uint64 k256[ak_mpzn256_size] =
	{ 0x4FED924594DCEAB3LL, 0x6DE33814E95B7FE6LL, 0x2823C8CF6FCC7B95LL, 0x77105C9B20BCD312LL };

	/* k = 179BA99116590342 1F71C51ED3DED665 8F25C1CF062FFDB8 768C272A4DF6E53E */
	ak_uint64 kMicron256[ak_mpzn256_size] =
	{ 0x768C272A4DF6E53ELL, 0x8F25C1CF062FFDB8LL, 0x1F71C51ED3DED665LL, 0x179BA99116590342LL };

	/* k = 3EE5F64D2A278C76 B8FD2F06CFC1258F 65D6DED31EC5711F 4203591691A99B17 */
	ak_uint64 kMicron256_[ak_mpzn256_size] =
	{ 0x4203591691A99B17LL, 0x65D6DED31EC5711FLL, 0xB8FD2F06CFC1258FLL, 0x3EE5F64D2A278C76LL };


	/* k = 359E7F4B1410FEACC570456C6801496946312120B39D019D455986E364F365886748ED7A44B3E794434006011842286212273A6D14CF70EA3AF71BB1AE679F1 */
	ak_uint64 k512[ak_mpzn512_size] =
	{ 0xA3AF71BB1AE679F1LL, 0x212273A6D14CF70ELL, 0x4434006011842286LL, 0x86748ED7A44B3E79LL,
		0xD455986E364F3658LL, 0x946312120B39D019LL, 0xCC570456C6801496LL, 0x0359E7F4B1410FEALL };

	/* результирующие последовательности - электронные подписи, также представляются последовательностями байт */
	ak_uint8 sign256[64] =
	{ 0x93, 0x04, 0xDC, 0x39, 0xFD, 0x43, 0xD0, 0x3A, 0xB8, 0x67, 0x27, 0xA4, 0x54, 0x35, 0x05, 0x74,
		0x19, 0xA4, 0xED, 0x6F, 0xD5, 0x9E, 0xCD, 0x80, 0x82, 0x14, 0xAB, 0xF1, 0xD2, 0x28, 0xAA, 0x41,
		0x40, 0x9C, 0xBF, 0xC5, 0xF6, 0x14, 0x80, 0x92, 0xDF, 0x31, 0xB6, 0x46, 0xF7, 0xD3, 0xD6, 0xBC,
		0x49, 0x02, 0xA6, 0x98, 0x5A, 0x23, 0x3C, 0x65, 0xA1, 0x42, 0x46, 0xBA, 0x64, 0x6C, 0x45, 0x01 };

	ak_uint8 sign512[128] =
	{ 0x36, 0xAE, 0x73, 0xE1, 0x44, 0x93, 0xE1, 0x17, 0x33, 0x5C, 0x9C, 0xCD, 0xCB, 0x3B, 0xC9, 0x60,
		0x02, 0x85, 0x99, 0x06, 0xC9, 0x97, 0xC1, 0x9E, 0x1C, 0x0F, 0xB2, 0x86, 0x84, 0x55, 0x92, 0x54,
		0xD3, 0xAC, 0xFC, 0xA8, 0xEE, 0x78, 0x3C, 0x64, 0xC2, 0xDC, 0xE0, 0x2E, 0xC8, 0xA3, 0x12, 0xE5,
		0x9E, 0x68, 0x3C, 0x1E, 0x5E, 0x79, 0xDD, 0x23, 0x1A, 0x09, 0x81, 0xA0, 0x60, 0xFA, 0x86, 0x2F,
		0x4A, 0x5B, 0x3E, 0xE7, 0xBD, 0x53, 0x98, 0x2A, 0xB9, 0x9C, 0x91, 0x56, 0x1F, 0xEB, 0x6E, 0x6A,
		0x40, 0xCE, 0x70, 0x7F, 0xDF, 0x80, 0x60, 0x52, 0x62, 0xF3, 0xC4, 0xE8, 0x88, 0xE2, 0x3C, 0x82,
		0xF5, 0x2F, 0xD5, 0x33, 0xE9, 0xFB, 0x0B, 0x1C, 0x08, 0xBC, 0xAD, 0x8A, 0x77, 0x56, 0x5F, 0x32,
		0xB6, 0x26, 0x2D, 0x36, 0xA9, 0xE7, 0x85, 0x65, 0x8E, 0xFE, 0x6F, 0x69, 0x94, 0xB3, 0x81, 0x10 };

#ifndef LIBAKRYPT_LITTLE_ENDIAN
	int i = 0;
#endif
	ak_uint64 e[64];
	char *str = NULL;
	struct signkey sk;
	ak_uint8 sign[128];
	struct verifykey pk;
	int error = ak_error_ok, audit = ak_log_get_level();

	if (audit >= ak_log_maximum)
		ak_error_message(ak_error_ok, __func__, "testing digital signatures started");

	/* 1. первый пример из приложения А ГОСТ Р 34.10-2012. */
	if ((error = ak_signkey_context_create_streebog256(&sk,
		(ak_wcurve)&id_tc26_gost_3410_2012_256_paramSetA)) != ak_error_ok) {
		ak_error_message(error, __func__,
			"incorrect creation of 256 bits secret key for GOST R 34.10-2012");
		return ak_false;
	}

	if ((error = ak_signkey_context_set_key(&sk, keyMicron256_, sizeof(keyMicron256), ak_true)) != ak_error_ok) {
		ak_error_message(error, __func__, "incorrect assigning a constant key value");
		ak_signkey_context_destroy(&sk);
		return ak_false;
	}
	ak_log_set_message((str = ak_ptr_to_hexstr(keyMicron256, 32, ak_true))); free(str);

	memset(sign, 0, 64);
	ak_signkey_context_sign_const_values(&sk,  kMicron256_, eMicron256_ ,sign);
	if (ak_ptr_is_equal(sign, (ak_pointer)sign256, 64)) {
		if (audit >= ak_log_maximum)
			ak_error_message(ak_error_ok, __func__,
				"digital signature generation process from GOST R 34.10-2012 (for 256 bit curve) is Ok");
	}
	else {
		ak_error_message(ak_error_not_equal_data, __func__,
			"digital signature generation process from GOST R 34.10-2012 (for 256 bit curve) is wrong");
		ak_log_set_message((str = ak_ptr_to_hexstr(sign, 64, ak_true))); free(str);
	//	ak_log_set_message((str = ak_ptr_to_hexstr((ak_pointer)sign256, 64, ak_true))); free(str);
		ak_signkey_context_destroy(&sk);
		return ak_false;
	}

	if ((error = ak_verifykey_context_create_from_signkey(&pk, &sk)) != ak_error_ok) {
		ak_error_message(error, __func__, "incorrect creation of digital signature public key");
		ak_signkey_context_destroy(&sk);
		return ak_false;
	}
	ak_signkey_context_destroy(&sk);

	/* поскольку проверка выполняется для результата функции хеширования, то мы
	преобразуем последовательность 64х битных интов в последовательность байт */
#ifdef LIBAKRYPT_LITTLE_ENDIAN
	memcpy(e, e256, 32);
#else
	for (i = 0; i < ak_mpzn256_size; i++) ((ak_uint64 *)e)[i] = bswap_64(e256[i]);
#endif

	if (ak_verifykey_context_verify_hash(&pk, e, 32, sign)) {
		if (audit >= ak_log_maximum)
			ak_error_message(ak_error_ok, __func__,
				"digital signature verification process from GOST R 34.10-2012 (for 256 bit curve) is Ok");
	}
	else {
		ak_error_message(ak_error_not_equal_data, __func__,
			"digital signature verification process from GOST R 34.10-2012 (for 256 bit curve) is wrong");
		ak_log_set_message((str = ak_ptr_to_hexstr(sign, 64, ak_true))); free(str);
		ak_verifykey_context_destroy(&pk);
		return ak_false;
	}
	ak_verifykey_context_destroy(&pk);

	/* 2. Второй пример из приложения А ГОСТ Р 34.10-2012. */
	if ((error = ak_signkey_context_create_streebog512(&sk,
		(ak_wcurve)&id_tc26_gost_3410_2012_512_paramSetTest)) != ak_error_ok) {
		ak_error_message(error, __func__,
			"incorrect creation of 512 bits secret key for GOST R 34.10-2012");
		return ak_false;
	}

	if ((error = ak_signkey_context_set_key(&sk, key512, sizeof(key512), ak_true)) != ak_error_ok) {
		ak_error_message(error, __func__, "incorrect assigning a constant key value");
		ak_signkey_context_destroy(&sk);
		return ak_false;
	}

	memset(sign, 0, 128);
	ak_signkey_context_sign_const_values(&sk, k512, e512, sign);
	if (ak_ptr_is_equal(sign, (ak_pointer)sign512, 128)) {
		if (audit >= ak_log_maximum)
			ak_error_message(ak_error_ok, __func__,
				"digital signature generation process from GOST R 34.10-2012 (for 512 bit curve) is Ok");
	}
	else {
		ak_error_message(ak_error_not_equal_data, __func__,
			"digital signature generation process from GOST R 34.10-2012 (for 512 bit curve) is wrong");
		ak_log_set_message((str = ak_ptr_to_hexstr(sign, 128, ak_true))); free(str);
		ak_log_set_message((str = ak_ptr_to_hexstr((ak_pointer)sign512, 128, ak_true))); free(str);
		ak_signkey_context_destroy(&sk);
		return ak_false;
	}

	if ((error = ak_verifykey_context_create_from_signkey(&pk, &sk)) != ak_error_ok) {
		ak_error_message(error, __func__, "incorrect creation of digital signature public key");
		ak_signkey_context_destroy(&sk);
		return ak_false;
	}
	ak_signkey_context_destroy(&sk);

	/* поскольку проверка выполняется для результата функции хеширования, то мы
	преобразуем последовательность 64х битных интов в последовательность байт */
#ifdef LIBAKRYPT_LITTLE_ENDIAN
	memcpy(e, e512, 64);
#else
	for (i = 0; i < ak_mpzn512_size; i++) ((ak_uint64 *)e)[i] = bswap_64(e512[i]);
#endif

	if (ak_verifykey_context_verify_hash(&pk, e, 64, sign)) {
		if (audit >= ak_log_maximum)
			ak_error_message(ak_error_ok, __func__,
				"digital signature verification process from GOST R 34.10-2012 (for 512 bit curve) is Ok");
	}
	else {
		ak_error_message(ak_error_not_equal_data, __func__,
			"digital signature verification process from GOST R 34.10-2012 (for 512 bit curve) is wrong");
		ak_log_set_message((str = ak_ptr_to_hexstr(sign, 64, ak_true))); free(str);
		ak_verifykey_context_destroy(&pk);
		return ak_false;
	}
	ak_verifykey_context_destroy(&pk);

	/* 3. Тестирование случайно сгенеренных электронных подписей для всех определенных
	эллиптических кривых */
//	if (!ak_signkey_test_random_signatures()) return ak_false;

	if (audit >= ak_log_maximum) ak_error_message(ak_error_get_value(), __func__,
		"testing digital signatures ended successfully");
	return ak_true;
}


bool_t test_magma(void)
{
	char *str = NULL;
	ak_uint8 out[32];
	struct bckey bkey; /* контекст используемого для тестов ключа */
	int error = ak_error_ok, audit = ak_log_get_level();
	bool_t result = ak_true;

	ak_uint8 gost3412_2015_key[32] = { /* тестовый ключ из ГОСТ Р 34.12-2015, приложение А.2 */
		0xff, 0xfe, 0xfd, 0xfc, 0xfb, 0xfa, 0xf9, 0xf8, 0xf7, 0xf6, 0xf5, 0xf4, 0xf3, 0xf2, 0xf1, 0xf0,
		0x00, 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77, 0x88, 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff
	};


	ak_uint8 gost3412_2015_key_micron_be[32] = { 0xC6, 0x9d, 0xa4, 0xfe, 0xb4, 0x9b, 0x6b, 0x96, 0x5c, 0x73, 0xcc, 0xb8, 0x28, 0x61, 0x99, 0x14,
		0x22, 0x30, 0xa0, 0xc0, 0xf1, 0x26, 0x63, 0xcc, 0x4c, 0x06, 0x10, 0x90, 0x3d, 0x83, 0xfa, 0x87 };

	ak_uint8 gost3412_2015_key_micron[32] = { 0x87, 0xFA, 0x83, 0x3D, 0x90, 0x10, 0x06, 0x4C, 0xCC, 0x63, 0x26, 0xF1, 0xC0, 0xA0, 0x30, 0x22,
		 0x14 , 0x99 , 0x61 , 0x28 , 0xB8 , 0xCC , 0x73 , 0x5C , 0x96 , 0x6B , 0x9B , 0xB4 , 0xFE , 0xA4 , 0x9D , 0xC6 };
	ak_uint8 micron_in[16] = { 0x00 , 0x01 , 0x02 , 0x03 , 0x04 , 0x05 , 0x06 , 0x07, 0x00 , 0x01 , 0x02 , 0x03 , 0x04 , 0x05 , 0x06 , 0x07 };
	ak_uint8 micron_in_be[16] = { 0x07 , 0x06 , 0x05 , 0x04 , 0x03 , 0x02 , 0x01 , 0x00, 0x07 , 0x06 , 0x05 , 0x04 , 0x03 , 0x02 , 0x01 , 0x00 };
	ak_uint8 micron_iv[4] = { 0x00, 0x00, 0x00, 0x00 };

	/* подлежащий зашифрованию открытый текст из ГОСТ Р 34.12-2015, приложение А.2 */
	ak_uint8 a[8] = { 0x10, 0x32, 0x54, 0x76, 0x98, 0xba, 0xdc, 0xfe };
	/* зашифрованный текст из ГОСТ Р 34.12-2015 */
	ak_uint8 b[8] = { 0x3d, 0xca, 0xd8, 0xc2, 0xe5, 0x01, 0xe9, 0x4e };

	/* открытый текст из ГОСТ Р 34.13-2015, приложение А.2 */
	ak_uint8 in_3413_2015_text[32] = {
		0x59, 0x0a, 0x13, 0x3c, 0x6b, 0xf0, 0xde, 0x92, 0x20, 0x9d, 0x18, 0xf8, 0x04, 0xc7, 0x54, 0xdb,
		0x4c, 0x02, 0xa8, 0x67, 0x2e, 0xfb, 0x98, 0x4a, 0x41, 0x7e, 0xb5, 0x17, 0x9b, 0x40, 0x12, 0x89 };

	/* зашифрованный в режиме простой замены текст из ГОСТ Р 34.13-2015, приложение А.2 */
	ak_uint8 out_3413_2015_ecb_text[32] = {
		0xa0, 0x72, 0xf3, 0x94, 0x04, 0x3f, 0x07, 0x2b, 0x48, 0x6e, 0x55, 0xd3, 0x15, 0xe7, 0x70, 0xde,
		0x1e, 0xbc, 0xcf, 0xea, 0xe9, 0xd9, 0xd8, 0x11, 0xfb, 0x7e, 0xc6, 0x96, 0x09, 0x26, 0x68, 0x7c };

	/* синхропосылка и зашифрованный в режиме гаммирования текст из ГОСТ Р 34.13-2015, приложение А.2 */
	ak_uint8 ctr_iv[4] = { 0x78, 0x56, 0x34, 0x12 },
		xiv1[4] = { 0x61, 0x2D, 0x93, 0x42 };

	ak_uint8 out_3413_2015_ctr_text[32] = {
		0x3c, 0xb9, 0xb7, 0x97, 0x0c, 0x11, 0x98, 0x4e, 0x69, 0x5d, 0xe8, 0xd6, 0x93, 0x0d, 0x25, 0x3e,
		0xef, 0xdb, 0xb2, 0x07, 0x88, 0x86, 0x6d, 0x13, 0x2d, 0xa1, 0x52, 0xab, 0x80, 0xb6, 0x8e, 0x56 };
	

	ak_uint8 xin1[13] = {
		0x31, 0xEA, 0x54, 0xBB, 0xB7, 0xE5, 0xE5, 0x1C, 0xAE, 0xEB, 0x79, 0x28, 0x71 };
	ak_uint8 xout1[13] = {
		0x7C, 0xC9, 0x83, 0x3D, 0x5D, 0x1B, 0x9E, 0x81, 0x07, 0x94, 0x9F, 0x58, 0x15 };

	/* тестовое значение имитовставки */
	ak_uint8 imito[8] = { 0xBB, 0xC5, 0x30, 0x20, 0x10, 0x72, 0x4E, 0x15 };

	/* 1. Инициализируем ключ алгоритма Магма */
	if ((error = ak_bckey_context_create_magma(&bkey)) != ak_error_ok) {
		ak_error_message(error, __func__, "wrong initialization of magma secret key");
		return ak_false;
	}

	/* 2. Присваиваем ключу константное значение */

	if (ak_bckey_context_set_key(&bkey, gost3412_2015_key_micron_be, 32, ak_false) != ak_error_ok) {
		ak_error_message(error, __func__, "wrong assigning a predefined value to magma secret key ");
		return ak_false;
	}

	/* 3. Тестируем зашифрование/расшифрование одного блока согласно ГОСТ Р34.12-2015 */

	bkey.encrypt(&bkey.key, micron_in_be, out);
	if (!ak_ptr_is_equal(out, b, 8)) {
		ak_error_message_fmt(ak_error_not_equal_data, __func__,
			"the one block encryption test from GOST R 34.12-2015 is wrong");
		ak_log_set_message(str = ak_ptr_to_hexstr(out, 8, ak_true)); free(str);
		ak_log_set_message(str = ak_ptr_to_hexstr(micron_in, 8, ak_true)); free(str);
		result = ak_false;
	//	goto exit;
	}

	/* 4. Тестируем режим простой замены согласно ГОСТ Р34.13-2015 */
	if ((error = ak_bckey_context_encrypt_ecb(&bkey, micron_in_be, out, 16)) != ak_error_ok)
	{
		ak_error_message_fmt(error, __func__, "wrong plain text encryption");
		result = ak_false;
		goto exit;
	}
	/* 5. Тестируем режим гаммирования (счетчика) согласно ГОСТ Р34.13-2015 */
	if (ak_bckey_context_xcrypt(&bkey, micron_in_be, out, 16, micron_iv, sizeof(micron_iv)) != ak_error_ok) {
		ak_error_message_fmt(ak_error_get_value(), __func__, "wrong plain text encryption");
		result = ak_false;
		goto exit;
	}

	/* 7. Тестируем режим выработки имитовставки (плоская реализация). */
	ak_bckey_context_omac(&bkey, micron_in_be, sizeof(micron_in_be), out);
	if ((error = ak_error_get_value()) != ak_error_ok) {
		ak_error_message(error, __func__, "wrong omac calculation");
		result = ak_false;
	//	goto exit;
	}


		/* 7. Тестируем режим выработки имитовставки (плоская реализация). */
	ak_bckey_context_omac(&bkey, in_3413_2015_text, sizeof(in_3413_2015_text), out);
	if ((error = ak_error_get_value()) != ak_error_ok) {
		ak_error_message(error, __func__, "wrong omac calculation");
		result = ak_false;
	//	goto exit;
	}
	if (!ak_ptr_is_equal(out, imito, 8)) {
		ak_error_message(ak_error_not_equal_data, __func__,
			"the omac integrity mode test from GOST R 34.13-2015 is wrong");
		ak_log_set_message(str = ak_ptr_to_hexstr(out, 8, ak_true)); free(str);
		ak_log_set_message(str = ak_ptr_to_hexstr(imito, 8, ak_true)); free(str);
		result = ak_false;
		goto exit;
	}
	if (audit >= ak_log_maximum) ak_error_message(ak_error_ok, __func__,
		"the omac integrity mode test from GOST R 34.13-2015 is Ok");

	/* освобождаем ключ и выходим */
exit:
	if ((error = ak_bckey_context_destroy(&bkey)) != ak_error_ok) {
		ak_error_message(error, __func__, "wrong destroying of magma secret key");
		return ak_false;
	}

	return result;
}

 int main( void )
{
 /* инициализируем библиотеку. в случае возникновения ошибки завершаем работу */
  if( ak_libakrypt_create( ak_function_log_stderr ) != ak_true ) {
    return ak_libakrypt_destroy();
  }

 /* ...
       здесь код Вашей программы

       в качестве примера мы выполняем динамическое
       тестирование криптографических механизмов с
       помощью функции                                ... */

       //ak_libakrypt_dynamic_control_test();
	   // ak_bckey_test_magma();
	 // test_magma();
  //signkey_test();
 // test_streebog256();
 // ak_hmac_test_streebog();

  hmac_test_pbkdf2();
   hmac_test_streebog();
	//	ak_libakrypt_test_block_ciphers();
 return ak_libakrypt_destroy();
}
